﻿using HarmonyLib;
using Vintagestory.API.Client;
using Vintagestory.API.Common;
using Vintagestory.API.Config;
using Vintagestory.API.Server;

namespace AurorasClasses
{
    /// <summary>
    /// 
    /// </summary>
    [HarmonyPatch]
    public class Core : ModSystem
    {
        public static string id = "aurorasclasses";
        private ICoreAPI api;
        private Harmony harmony;

        // Called on server and client
        // Useful for registering block/entity classes on both sides
        public override void Start(ICoreAPI api)
        {
            this.api = api;
            api.Logger.Notification("aurorasclasses:init");

            harmony = new Harmony(id);
            harmony.PatchAll();

            api.Logger.Notification(api is ICoreServerAPI ? Lang.Get("aurorasclasses:init-server-loaded") : Lang.Get("aurorasclasses:init-client-loaded"));

        }


        public override void StartClientSide(ICoreClientAPI api)
        {
            api.Logger.Notification(Lang.Get("aurorasclasses:init-client"));
        }

        public override void Dispose()
        {
            harmony.UnpatchAll(id);
        }
    }
}