﻿using HarmonyLib;
using System.Collections.Generic;
using System.Linq;
using Vintagestory.API.Common;
using Vintagestory.GameContent;

namespace AurorasClasses.classes;

[HarmonyPatch]
public class Alchemist
{
    public static List<CharacterClass> CharacterClasses = new()
    {
        new CharacterClass()
        {
            Code = "alchemist",
            Gear = new JsonItemStack[]
            {
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-head-alchemist"),
                },
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-upperbody-alchemist"),
                },
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-shoulder-alchemist"),
                },
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-waist-alchemist"),
                },
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-lowerbody-alchemist"),
                },
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-foot-alchemist"),
                },
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-emblem-blue-seal"),
                },
                new()
                {
                    Type = EnumItemClass.Item,
                    Code = new AssetLocation("game", "clothes-face-snow-goggles"),
                }
            },
            Traits = new []
            {
                "resourceful", "forager", "furtive", "precise", "nervous", "soft-handed", "frail"
            }
        },
    };

    public static List<Trait> traits = new()
    {
        
        new Trait
        {
            Code = "soft-handed",
            Attributes = new Dictionary<string, double>() {
                {"miningSpeedMul", -0.15},
                {"oreDropRate", -0.2},
                {"animalHarvestingTime", -0.1},
                {"forageDropRate", -0.1},
                {"wildCropDropRate", -0.1}
            },
            Type = EnumTraitType.Negative
        },
    };

    [HarmonyPostfix]
    [HarmonyPatch(typeof(CharacterSystem), "loadCharacterClasses")]
    public static void ShowCharacterClasses(CharacterSystem __instance)
    {
        foreach (var trait in traits.Where(trait => !__instance.traits.Contains(trait)))
        {
            __instance.traits.Add(trait);
            __instance.TraitsByCode[trait.Code] = trait;
        }

        foreach (var characterClass in CharacterClasses.Where(characterClass => !__instance.characterClasses.Contains(characterClass)))
        {
            __instance.characterClasses.Add(characterClass);
            __instance.characterClassesByCode[characterClass.Code] = characterClass;
        }
    }
}